\FACT.XPL	OCT-01-93
\FACTORIAL BENCHMARK
\BY CURT MOTT
\MODIFIED BY L.B.

\REVISIONS:
\MAY-17-87, ORIGINAL
\OCT-01-93, MODIFIED FOR PC

code	REM= 2,		RESERVE= 3,	CRLF= 9,	INTIN= 10,
	INTOUT =11,	TEXT= 12,	OPENO= 14,	CLOSE= 15;

def	INTSIZE= 2;	\4;
def	RADIX= 100;	\1000000;

int	L, N, DEV;
int	F;



proc	NUMOUT(DEV, N);	\Output N with leading zeros
int	DEV, N;
int	M;
begin
M:= N;
if M = 0 then M:= 1;
loop	begin
	M:= M *10;
	if M >= RADIX then quit;
	INTOUT(DEV, 0);			\Output a leading zero
	end;
INTOUT(DEV, N);
end;	\NUMOUT



proc	SHOWNUM(DEV);
int	DEV;
int	I;
begin
I:= L;
INTOUT(DEV, F(I));
I:= I -1;
while I >= 1 do
	begin
	NUMOUT(DEV, F(I));
	I:= I -1;
	end;
end;	\SHOWNUM



proc	FACT;
int	I;
int	J, C;
begin
L:= 1;
F(1):= 1;

for I:= 1, N do
	begin
	C:= 0;
	for J:= 1, L do
		begin
		C:= (F(J) *I +C) /RADIX;
		F(J):= REM(0);
		end;
	if C > 0 then
		begin
		L:= L +1;
		F(L):= C;
		end;
	end;
end;	\FACT



begin	\MAIN
F:= RESERVE(2000 *INTSIZE);

TEXT(0,"
-- FACTORIAL CALCULATOR --
");
DEV:= 0;
OPENO(DEV);

loop	begin
	CRLF(DEV);
	TEXT(0,"Enter number (0-115): ");
	N:= INTIN(0);
	if N < 0 then quit;
	FACT;
	CRLF(DEV);
	INTOUT(DEV, N); TEXT(DEV,"! = ");
	SHOWNUM(DEV);
	CRLF(DEV);
	end;
CLOSE(DEV);
end;	\MAIN
